
var fso = new ActiveXObject('Scripting.FileSystemObject');
var WorkSpace = GetWorkspace;
var project = WorkSpace.DM_FocusedProject();
path = "C:\\"
if (project) {
    path = project.DM_GetOutputPath();
    path = fso.getParentFolderName(path);
} 
var CurrentDirectory =  path;
var source = CurrentDirectory;
var des = CurrentDirectory + '\\ascii';
var logDir = des + '\\log';
var logPath = logDir + '\\log.txt';
var saveCount = 1000;
var maxCapacity = 1000;
var nowCount = 0;
var nowCapacity = 0;
var log = 2;
var fso = new ActiveXObject('Scripting.FileSystemObject');
var convertSuccess = []
var convertFail = []
adSourceText.Caption =  source
adOutputText.Caption =  des
function createDir(path) {
    if (!fso.FolderExists(path)) {
        fso.CreateFolder(path);
    }
}
function checkDirPath(path) {
    var rex = new RegExp(/\\([^\\]+)/g);
    var dir = [];
    var res;
    var start;
    while ((res = rex.exec(path)) != null) {
        if (!start) start = res.index;
        dir.push(res[1]);
    }
    var _path = path.slice(0, start);
    for (var i = 0; i < dir.length; i++) {
        _path += '\\' + dir[i];
        createDir(_path);
    }
}
function console(key, value) {
    var logFile = fso.OpenTextFile(logPath, log, true);
    if(key!=""){
        logFile.write(key);
        logFile.write(':');
    }
    logFile.write(value);
    logFile.write('\r\n');
    logFile.Close();
    if (log == 2) {
        log = 8;
    }
}
var libsPath;
function getAllLib(source) {
    var schLibPaths = [];
    var pcbLibPaths = [];
    var intLibPaths = [];
    if (fso.FolderExists(source)) {
        saveFolderFile(source);
    } else if (fso.FileExists(source)) {
        saveFile(source);
    } else {
        console('error', 'The source file path does not exist');
    }
    function saveFile(path) {
        var type = path.toString().toLowerCase();
        if (type.match(/.pcblib$/)) return pcbLibPaths.push(path);
        if (type.match(/.schlib$/)) return schLibPaths.push(path);
        if (type.match(/.intlib$/)) return intLibPaths.push(path);
    }
    function saveFolderFile(libDir) {
        var folder = fso.GetFolder(libDir);
        var files = new Enumerator(folder.files);
        var folders = new Enumerator(folder.SubFolders);
        while (!files.atEnd()) {
            var fileName = files.item().name;
            if (fileName == undefined) {
                files.moveNext();
                continue;
            }
            saveFile(libDir + '\\' + fileName);
            files.moveNext();
        }
        while (!folders.atEnd()) {
            var fName = folders.item().name;
            saveFolderFile(libDir + '\\' + fName);
            folders.moveNext();
        }
    }
    return { schLibPaths: schLibPaths, pcbLibPaths: pcbLibPaths, intLibPaths: intLibPaths };
}
var availableLibraryPaths;
function getAllLib2(del) {
    var libsCount = IntegratedLibraryManager.AvailableLibraryCount();
    var schLibPaths = [];
    var pcbLibPaths = [];
    var intLibPaths = [];
    var paths = [];
    for (var i = 0; i < libsCount; i++) {
        var type = IntegratedLibraryManager.AvailableLibraryType(i);
        var path = IntegratedLibraryManager.AvailableLibraryPath(i);
        paths.push(path);
        if (type == 0) {
            intLibPaths.push(path);
        } else if (type == 1) {
            schLibPaths.push(path);
        } else if (type == 2) {
            pcbLibPaths.push(path);
        }
    }
    availableLibraryPaths = paths;
    return { schLibPaths: schLibPaths, pcbLibPaths: pcbLibPaths, intLibPaths: intLibPaths };
}
function includes(arr, path) {
    for (var i = 0; i < arr.length; i++) {
        if (arr[i] == path) return true;
    }
    return false;
}
function getDesPath(path, suffix){
    var newfile=path.replace(source,des);
    var dir=fso.GetParentFolderName(newfile);
    checkDirPath(dir);
    return  delSuffix(newfile) + suffix
}
function delSuffix(path){
    var index = path.lastIndexOf(".")
    if(index!=-1){
        return path.slice(0,index)
    }
    return path
}
function getOutDir(del) {
    checkDirPath(des);
    createDir(logDir);
    return des;
}
function newTempFile(del) {
    return des + '\\' + dt();
}
function dt(del) {
    return Date.parse(new Date()).toString();
}

function getFileName(path, suffix) {
    var fName = fso.getFileName(path);
    var fpath = des + '\\' + fName.slice(0, -7) + suffix;
    return fpath;
}
function a_getAllLibsByCustomLibsPath(render) {
    if (!availableLibraryPaths) getAllLib2();
    if (!libsPath) {
        libsPath = getAllLib(source);
        getOutDir();
    }
    extractFootprints_ByCustomLibsPath();
    extractSymbols_ByCustomLibsPath();
}
function extractSymbols_ByCustomLibsPath(render) {
    for (var i = 0; i < libsPath.schLibPaths.length; i++) {
        getSchemaByPath(libsPath.schLibPaths[i]);
    }
    for (var i = 0; i < libsPath.intLibPaths.length; i++) {
        getSchemaByPath(libsPath.intLibPaths[i]);
    }
}
function getSchemaByPath(libPath) {
try{
    var schPath = getDesPath(libPath,".schdoc")
    var tempPath;
    var oldPath = schPath;
    var schDocument;
    var splitNum = 1;
    var success = false;
    function OpenDocument(del) {
        nowCount = 0;
        nowCapacity = 0;
        tempPath = newTempFile() + '.schdoc';
        schDocument = Client.OpenDocument('SCH', tempPath);
        Client.ShowDocument(schDocument);
    }
    function saveDocument(del) {
        // console('sch out', '------------------------------------');
        // console('schPath', schPath);
        // console('tempPath', tempPath);
        schDocument.DoFileSave('SCH ASCII');
        Client.CloseDocument(schDocument);
        nowCount = 0;
        nowCapacity = 0;
        if (fso.FileExists(schPath)) fso.deleteFile(schPath);
        if (fso.FileExists(tempPath)) fso.moveFile(tempPath, schPath);
        else {
            return false
            // console('split', '------------------------------------');
            // console('error', 'failed to save document');
            // console('schPath', schPath);
            // console('tempPath', tempPath);
            // console('split', '------------------------------------');
        }
        schDocument = null;
        return true;
    }
    function getSplitNextName(del) {
        splitNum++;
        var index = oldPath.lastIndexOf(".")
        if(index!=-1){
            return oldPath.slice(0,index) + '_'+ (splitNum - 1) + oldPath.slice(index)
        }
        return oldPath + '_' + (splitNum - 1);
    }
    var has = includes(availableLibraryPaths, libPath);
    if (!has) IntegratedLibraryManager.InstallLibrary(libPath);
    var libCount = IntegratedLibraryManager.GetComponentCount(libPath);
    for (var i = 0; i < libCount; i++) {
        if (!schDocument) OpenDocument();
        var compName = IntegratedLibraryManager.GetComponentName(libPath, i);
        IntegratedLibraryManager.PlaceLibraryComponent(compName, libPath, 'Orientation=0|Location.X=50000000|Location.Y=50000000');
        nowCount++;
        nowCapacity++;
        if (nowCount >= saveCount) {
            schDocument.DoFileSave('SCH ASCII');
            nowCount = 0;
        }
        if (nowCapacity > maxCapacity) {
            saveDocument();
            schPath = getSplitNextName();
        }
    }
    success = saveDocument();
    if(success){
        convertSuccess.push({libPath:libPath,isSch:true})
    }else{
        convertFail.push({libPath:libPath,isSch:true})
    }
    if (!has) IntegratedLibraryManager.UninstallLibrary(libPath);
}catch(e){
    convertFail.push({libPath:libPath,isSch:true})
}
}

function extractFootprints_ByCustomLibsPath(render) {
    
    // console('run method', 'extractFootprints');
    for (var i = 0; i < libsPath.pcbLibPaths.length; i++) {
        // console('pcblibsPath', libsPath.pcbLibPaths[i]);
        getPcbByPath(libsPath.pcbLibPaths[i], 2);
    }
    for (var i = 0; i < libsPath.intLibPaths.length; i++) {
        getPcbByPath(libsPath.intLibPaths[i], 0);
    }
    
}
function getPcbByPath(libPath, type) {
try{
    if (type == 2) {
        generatePcbDoc1(libPath)
        // if (PCBServer) {
        //     try{
        //         PCBServer.LoadPCBLibraryFromFile(libPath);
        //     }catch(e){
                
        //         return;
        //     }
        //     generatePcbDoc(libPath);
        // } else {
        //     convertFail.push({libPath:libPath,isPcb:true})
        //     console('there is no PCBServer', libPath);
        // }
        
    } else if (type == 0) {
        IntegratedLibraryManager.ExtractSources(libPath);
        var res = getAllLib(delSuffix(libPath));
        for (var i = 0; i < res.pcbLibPaths.length; i++) {
            var _libPath = res.pcbLibPaths[i];
            // console('_libPath', _libPath);
            getPcbByPath(_libPath,2);
        }
    }
}catch(e){
    convertFail.push({libPath:libPath,isPcb:true})
}
}
function generatePcbDoc(libPath){
    var success = true;
    var modelNames = [];
    try{
        var PcbLib = PCBServer.LoadPCBLibraryFromFile(libPath);
        if (PcbLib) {
            var LibIterator = PcbLib.LibraryIterator_Create;
            var LibComponent = LibIterator.FirstPCBObject;
            while (LibComponent != null) {
                modelNames.push(LibComponent.name)
                LibComponent = LibIterator.NextPCBObject;
            }
            PcbLib.LibraryIterator_Destroy(LibIterator);
            PCBServer.DestroyPCBLibrary(PcbLib);
            success = generatePcbDocByModelNames(libPath,modelNames)
        } else {
            success = false;
            Client.CloseDocument(pcbDocument);
        }
    }catch(e){
        success = false
    }
    if(success){
        convertSuccess.push({libPath:libPath,isPcb:true})
    }else{
        convertFail.push({libPath:libPath,isPcb:true})
    }
    
}
function generatePcbDoc1(libPath){
    var success = true;
    var pcbDocument;
    var modelNames = [];
    try{
        pcbDocument = Client.OpenDocument('PCBLIB', libPath);
        Client.ShowDocument(pcbDocument);
        var PcbLib = PCBServer.GetCurrentPCBLibrary
        if (PcbLib) {
            var LibIterator = PcbLib.LibraryIterator_Create;
            var LibComponent = LibIterator.FirstPCBObject;
            while (LibComponent != null) {
                modelNames.push(LibComponent.name)
                LibComponent = LibIterator.NextPCBObject;
            }
            PcbLib.LibraryIterator_Destroy(LibIterator);
            Client.CloseDocument(pcbDocument);
            success = generatePcbDocByModelNames(libPath,modelNames)
        } else {
            success = false;
            Client.CloseDocument(pcbDocument);
        }
    }catch(e){
        success = false
        if(pcbDocument){
            Client.CloseDocument(pcbDocument);
        }
    }
    if(success){
        convertSuccess.push({libPath:libPath,isPcb:true})
    }else{
        convertFail.push({libPath:libPath,isPcb:true})
    }
}
function generatePcbDocByModelNames(libPath,modelNames){
    var Board;
    var pcbDocument;
    var splitNum = 1;
    var success = true;
    try{
        var pcbPath = getDesPath(libPath,".pcbdoc");
        var oldPath = pcbPath;
        var has = includes(availableLibraryPaths, libPath);
        if (!has) IntegratedLibraryManager.InstallLibrary(libPath);
        for(var i=0;i<modelNames.length;i++){
            var modelName = modelNames[i];
            addPcbComp(modelName);
            if (nowCount >= saveCount) {
                pcbDocument.DoFileSave('PCB Binary 5.0');
                nowCount = 0;
            }
            if (nowCapacity >= maxCapacity) {
                success = saveDocument() && success;
                nowCapacity = 0;
                pcbPath = getSplitNextName();
            }
        }
        success = saveDocument() && success;
    }catch(e){
        success = false;
        if (pcbDocument){
            pcbDocument.DoFileSave('PCB ASCII File');
            Client.CloseDocument(pcbDocument);
        }
    }
    return success;
    function addPcbComp(modelName) {
        if (!pcbDocument) OpenDocument();
        var Component = PCBServer.PCBObjectFactory(eComponentObject, eNoDimension, eCreate_Default);
        Component.SetState_Board(Board);
        Component.LoadFromLibrary('FileName=' + libPath + '|Footprint=' + modelName);
        Component.Layer = eV7_TopLayer;
        Component.SetState_XLocation(MMsToCoord(100));
        Component.SetState_YLocation(MMsToCoord(100));
        Board.AddPCBObject(Component);
        nowCount++;
        nowCapacity++;
    }
    function OpenDocument(del) {
        nowCount = 0;
        nowCapacity = 0;
        pcbDocument = Client.OpenDocument('PCB', pcbPath);
        Client.ShowDocument(pcbDocument);
        Board = PCBServer.GetCurrentPCBBoard;
    }
    function getSplitNextName(del) {
        var index = oldPath.lastIndexOf(".")
        splitNum++;
        if(index!=-1){
            return oldPath.slice(0,index) + '_'+ (splitNum-1) + oldPath.slice(index)
        }
        return oldPath+ '_'+ (splitNum-1)  
    }
    function saveDocument(del) {
        if (pcbDocument) {
            pcbDocument.DoFileSave('PCB ASCII File');
            Client.CloseDocument(pcbDocument);
            // console('pcb out', '------------------------------------');
            // console('pcbPath', pcbPath);
            // console('tempPath', tempPath);
            nowCount = 0;
            nowCapacity = 0;
            pcbDocument = null;
            if (!fso.FileExists(pcbPath)) {
                // convertFail.push(libPath)
                return false;
                // console('split', '------------------------------------');
                // console('error', 'failed to save document');
                // console('pcbPath', pcbPath);
                // console('tempPath', tempPath);
            }
            return true
        }
        return true
    }
}
function openDialog(sender){
     try {
            var Message = "";
            var Shell = new ActiveXObject("Shell.Application");
            var Folder = Shell.BrowseForFolder(0, Message, 0x0040, 0x11);
            if (Folder != null) {
                Folder = Folder.items();
                Folder = Folder.item();
                Folder = Folder.Path;
                return Folder;
            }
        }
        catch (e) {
            console("openfolder","false");
        }
}

function adSourceClick(Sender)
{
    var folder = openDialog();
    if(folder){
        adSourceText.Caption =  folder
        adOutputText.Caption =  folder + "\\"+"ascii"
    }
}

function adOutputClick(Sender)
{
    var folder = openDialog();
    if(folder){
        adOutputText.Caption =  folder
    }
}


function cancelButtonClick(Sender)
{
     Close;
}
function okButtonClick(Sender)
{
    source = adSourceText.Caption;
    des = adOutputText.Caption;
    logDir = des + '\\log';
    logPath = logDir + '\\log.txt';
    a_getAllLibsByCustomLibsPath()
    console("Convert Success",convertSuccess.length)
    for(var i=0;i<convertSuccess.length;i++){
        var res = convertSuccess[i]
        var path = res.libPath
        var key = ""
        if(res.isSch){
            key = "sch"
        }else if(res.isPcb){
            key = "pcb"
        }
        console(key,path)
    }
    console("Convert Fail",convertFail.length)
    for(var i=0;i<convertFail.length;i++){
        var res = convertFail[i]
        var path = res.libPath
        var key = ""
        if(res.isSch){
            key = "sch"
        }else if(res.isPcb){
            key = "pcb"
        }
        console(key,path)
    }
    showmessage("convert sucess")
    Close;

}

